/* tslint:disable */
/* eslint-disable */
/**
 * Coscine Web API
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, type RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
// @ts-ignore
import type { ProjectQuotaDtoPagedResponse } from '../../@coscine/model';
// @ts-ignore
import type { ProjectQuotaDtoResponse } from '../../@coscine/model';
// @ts-ignore
import type { ProjectQuotaForUpdateDto } from '../../@coscine/model';
/**
 * ProjectQuotaApi - axios parameter creator
 * @export
 */
export const ProjectQuotaApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {string} projectId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2ProjectsProjectIdQuotasOptions: async (projectId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('apiV2ProjectsProjectIdQuotasOptions', 'projectId', projectId)
            const localVarPath = `/api/v2/projects/{projectId}/quotas`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'OPTIONS', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves a project quota for a specified project and resource type.
         * @param {string} projectId The Id or slug of the project.
         * @param {string} resourceTypeId The ID of the resource type.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getProjectQuota: async (projectId: string, resourceTypeId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('getProjectQuota', 'projectId', projectId)
            // verify required parameter 'resourceTypeId' is not null or undefined
            assertParamExists('getProjectQuota', 'resourceTypeId', resourceTypeId)
            const localVarPath = `/api/v2/projects/{projectId}/quotas/{resourceTypeId}`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"resourceTypeId"}}`, encodeURIComponent(String(resourceTypeId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves all project quotas for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getProjectQuotas: async (projectId: string, pageNumber?: number, pageSize?: number, orderBy?: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('getProjectQuotas', 'projectId', projectId)
            const localVarPath = `/api/v2/projects/{projectId}/quotas`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (pageNumber !== undefined) {
                localVarQueryParameter['PageNumber'] = pageNumber;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['PageSize'] = pageSize;
            }

            if (orderBy !== undefined) {
                localVarQueryParameter['OrderBy'] = orderBy;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Updates a project quota for a specified project and resource type.
         * @param {string} projectId The Id or slug of the project.
         * @param {string} resourceTypeId The ID of the resource type.
         * @param {ProjectQuotaForUpdateDto} [projectQuotaForUpdateDto] The updated project quota data.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateProjectQuota: async (projectId: string, resourceTypeId: string, projectQuotaForUpdateDto?: ProjectQuotaForUpdateDto, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('updateProjectQuota', 'projectId', projectId)
            // verify required parameter 'resourceTypeId' is not null or undefined
            assertParamExists('updateProjectQuota', 'resourceTypeId', resourceTypeId)
            const localVarPath = `/api/v2/projects/{projectId}/quotas/{resourceTypeId}`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"resourceTypeId"}}`, encodeURIComponent(String(resourceTypeId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(projectQuotaForUpdateDto, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ProjectQuotaApi - functional programming interface
 * @export
 */
export const ProjectQuotaApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ProjectQuotaApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {string} projectId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV2ProjectsProjectIdQuotasOptions(projectId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV2ProjectsProjectIdQuotasOptions(projectId, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectQuotaApi.apiV2ProjectsProjectIdQuotasOptions']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves a project quota for a specified project and resource type.
         * @param {string} projectId The Id or slug of the project.
         * @param {string} resourceTypeId The ID of the resource type.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getProjectQuota(projectId: string, resourceTypeId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ProjectQuotaDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getProjectQuota(projectId, resourceTypeId, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectQuotaApi.getProjectQuota']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves all project quotas for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getProjectQuotas(projectId: string, pageNumber?: number, pageSize?: number, orderBy?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ProjectQuotaDtoPagedResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getProjectQuotas(projectId, pageNumber, pageSize, orderBy, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectQuotaApi.getProjectQuotas']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Updates a project quota for a specified project and resource type.
         * @param {string} projectId The Id or slug of the project.
         * @param {string} resourceTypeId The ID of the resource type.
         * @param {ProjectQuotaForUpdateDto} [projectQuotaForUpdateDto] The updated project quota data.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async updateProjectQuota(projectId: string, resourceTypeId: string, projectQuotaForUpdateDto?: ProjectQuotaForUpdateDto, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.updateProjectQuota(projectId, resourceTypeId, projectQuotaForUpdateDto, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectQuotaApi.updateProjectQuota']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * ProjectQuotaApi - factory interface
 * @export
 */
export const ProjectQuotaApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ProjectQuotaApiFp(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {ProjectQuotaApiApiV2ProjectsProjectIdQuotasOptionsRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2ProjectsProjectIdQuotasOptions(requestParameters: ProjectQuotaApiApiV2ProjectsProjectIdQuotasOptionsRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.apiV2ProjectsProjectIdQuotasOptions(requestParameters.projectId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves a project quota for a specified project and resource type.
         * @param {ProjectQuotaApiGetProjectQuotaRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getProjectQuota(requestParameters: ProjectQuotaApiGetProjectQuotaRequest, options?: RawAxiosRequestConfig): AxiosPromise<ProjectQuotaDtoResponse> {
            return localVarFp.getProjectQuota(requestParameters.projectId, requestParameters.resourceTypeId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves all project quotas for a specified project.
         * @param {ProjectQuotaApiGetProjectQuotasRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getProjectQuotas(requestParameters: ProjectQuotaApiGetProjectQuotasRequest, options?: RawAxiosRequestConfig): AxiosPromise<ProjectQuotaDtoPagedResponse> {
            return localVarFp.getProjectQuotas(requestParameters.projectId, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Updates a project quota for a specified project and resource type.
         * @param {ProjectQuotaApiUpdateProjectQuotaRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateProjectQuota(requestParameters: ProjectQuotaApiUpdateProjectQuotaRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.updateProjectQuota(requestParameters.projectId, requestParameters.resourceTypeId, requestParameters.projectQuotaForUpdateDto, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV2ProjectsProjectIdQuotasOptions operation in ProjectQuotaApi.
 * @export
 * @interface ProjectQuotaApiApiV2ProjectsProjectIdQuotasOptionsRequest
 */
export interface ProjectQuotaApiApiV2ProjectsProjectIdQuotasOptionsRequest {
    /**
     * 
     * @type {string}
     * @memberof ProjectQuotaApiApiV2ProjectsProjectIdQuotasOptions
     */
    readonly projectId: string
}

/**
 * Request parameters for getProjectQuota operation in ProjectQuotaApi.
 * @export
 * @interface ProjectQuotaApiGetProjectQuotaRequest
 */
export interface ProjectQuotaApiGetProjectQuotaRequest {
    /**
     * The Id or slug of the project.
     * @type {string}
     * @memberof ProjectQuotaApiGetProjectQuota
     */
    readonly projectId: string

    /**
     * The ID of the resource type.
     * @type {string}
     * @memberof ProjectQuotaApiGetProjectQuota
     */
    readonly resourceTypeId: string
}

/**
 * Request parameters for getProjectQuotas operation in ProjectQuotaApi.
 * @export
 * @interface ProjectQuotaApiGetProjectQuotasRequest
 */
export interface ProjectQuotaApiGetProjectQuotasRequest {
    /**
     * The Id or slug of the project.
     * @type {string}
     * @memberof ProjectQuotaApiGetProjectQuotas
     */
    readonly projectId: string

    /**
     * The desired page number. Should be greater than or equal to 1. Default is 1.
     * @type {number}
     * @memberof ProjectQuotaApiGetProjectQuotas
     */
    readonly pageNumber?: number

    /**
     * The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
     * @type {number}
     * @memberof ProjectQuotaApiGetProjectQuotas
     */
    readonly pageSize?: number

    /**
     * Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
     * @type {string}
     * @memberof ProjectQuotaApiGetProjectQuotas
     */
    readonly orderBy?: string
}

/**
 * Request parameters for updateProjectQuota operation in ProjectQuotaApi.
 * @export
 * @interface ProjectQuotaApiUpdateProjectQuotaRequest
 */
export interface ProjectQuotaApiUpdateProjectQuotaRequest {
    /**
     * The Id or slug of the project.
     * @type {string}
     * @memberof ProjectQuotaApiUpdateProjectQuota
     */
    readonly projectId: string

    /**
     * The ID of the resource type.
     * @type {string}
     * @memberof ProjectQuotaApiUpdateProjectQuota
     */
    readonly resourceTypeId: string

    /**
     * The updated project quota data.
     * @type {ProjectQuotaForUpdateDto}
     * @memberof ProjectQuotaApiUpdateProjectQuota
     */
    readonly projectQuotaForUpdateDto?: ProjectQuotaForUpdateDto
}

/**
 * ProjectQuotaApi - object-oriented interface
 * @export
 * @class ProjectQuotaApi
 * @extends {BaseAPI}
 */
export class ProjectQuotaApi extends BaseAPI {
    /**
     * 
     * @summary Responds with the HTTP methods allowed for the endpoint.
     * @param {ProjectQuotaApiApiV2ProjectsProjectIdQuotasOptionsRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectQuotaApi
     */
    public apiV2ProjectsProjectIdQuotasOptions(requestParameters: ProjectQuotaApiApiV2ProjectsProjectIdQuotasOptionsRequest, options?: RawAxiosRequestConfig) {
        return ProjectQuotaApiFp(this.configuration).apiV2ProjectsProjectIdQuotasOptions(requestParameters.projectId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves a project quota for a specified project and resource type.
     * @param {ProjectQuotaApiGetProjectQuotaRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectQuotaApi
     */
    public getProjectQuota(requestParameters: ProjectQuotaApiGetProjectQuotaRequest, options?: RawAxiosRequestConfig) {
        return ProjectQuotaApiFp(this.configuration).getProjectQuota(requestParameters.projectId, requestParameters.resourceTypeId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves all project quotas for a specified project.
     * @param {ProjectQuotaApiGetProjectQuotasRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectQuotaApi
     */
    public getProjectQuotas(requestParameters: ProjectQuotaApiGetProjectQuotasRequest, options?: RawAxiosRequestConfig) {
        return ProjectQuotaApiFp(this.configuration).getProjectQuotas(requestParameters.projectId, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Updates a project quota for a specified project and resource type.
     * @param {ProjectQuotaApiUpdateProjectQuotaRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectQuotaApi
     */
    public updateProjectQuota(requestParameters: ProjectQuotaApiUpdateProjectQuotaRequest, options?: RawAxiosRequestConfig) {
        return ProjectQuotaApiFp(this.configuration).updateProjectQuota(requestParameters.projectId, requestParameters.resourceTypeId, requestParameters.projectQuotaForUpdateDto, options).then((request) => request(this.axios, this.basePath));
    }
}

